// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(lib, def) {
      var i, j, len, len1, p, pinName, pinNumber, pinNumbers, ref;
      this.lib = lib;
      this.mergeObjects(this, def);
      this.refDes = 'REF';
      this.symbol = new QedaSymbol(this);
      this.patterns = [];
      this.pins = [];
      for (pinName in this.pinout) {
        pinNumbers = Array.isArray(this.pinout[pinName]) ? this.pinout[pinName] : [this.pinout[pinName]];
        for (i = 0, len = pinNumbers.length; i < len; i++) {
          pinNumber = pinNumbers[i];
          this.pins[pinNumber] = this._pinObj(pinNumber, pinName);
        }
      }
      if (!Array.isArray(this["package"])) {
        this["package"] = [this["package"]];
      }
      ref = this["package"];
      for (j = 0, len1 = ref.length; j < len1; j++) {
        p = ref[j];
        if (typeof p === 'object') {
          this.addPattern(p);
        } else if (typeof p === 'string') {
          if (this[p] != null) {
            this.addPattern(this[p]);
          }
        }
      }
    }

    QedaElement.prototype.calculate = function(gridSize) {
      var cap, def, handler, i, j, l, len, len1, len2, pattern, ref, ref1, ref2, ref3;
      if (this._calculated == null) {
        this._calculated = false;
      }
      if (this._calculated) {
        return;
      }
      handler = require("./element/" + this.lib.elementStyle);
      handler(this);
      if (((ref = this.schematics) != null ? ref.symbol : void 0) != null) {
        ref1 = this.lib.symbolDefs;
        for (i = 0, len = ref1.length; i < len; i++) {
          def = ref1[i];
          cap = def.regexp.exec(this.schematics.symbol);
          if (cap) {
            handler = require("./symbol/" + this.lib.symbolStyle + "/" + def.handler);
            handler.apply(null, [this.symbol].concat(slice.call(cap.slice(1))));
          }
        }
      }
      this.symbol.calculate(gridSize);
      ref2 = this.patterns;
      for (j = 0, len1 = ref2.length; j < len1; j++) {
        pattern = ref2[j];
        ref3 = this.lib.patternDefs;
        for (l = 0, len2 = ref3.length; l < len2; l++) {
          def = ref3[l];
          cap = def.regexp.exec(pattern.name);
          if (cap) {
            handler = require("./pattern/" + this.lib.patternStyle + "/" + def.handler);
            handler.apply(null, [pattern].concat(slice.call(cap.slice(1))));
          }
        }
      }
      return this._calculated = true;
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.addPattern = function(packageDef) {
      if (packageDef.pattern == null) {
        return;
      }
      return this.patterns.push(new QedaPattern(this, packageDef.pattern));
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var i, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['ground', 'in', 'inverted', 'out', 'power'];
        for (i = 0, len = props.length; i < len; i++) {
          prop = props[i];
          if (this.properties[prop] != null) {
            pins = Array.isArray(this.properties[prop]) ? this.properties[prop] : [this.properties[prop]];
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
